A1 = imread('Ani1.jpg');
A2 = imread('Ani2.jpg');
A1 = imresize(A1, [800 1200]);
A2 = imresize(A2, [800 1200]);

A1(isnan(A1))=255;
A2(isnan(A2))=255;

subplot(2,1,1)
%image(A1)
%axis image off ;
A1gray = single(rgb2gray(A1)) ;
[f1,d1] = vl_sift(A1gray) ;

perm = randperm(size(f1,2)) ;
sel = perm(1:end) ;

h1 = vl_plotframe(f1(:,sel)) ;
h2 = vl_plotframe(f1(:,sel)) ;
set(h1,'color','k','linewidth',3) ;
set(h2,'color','y','linewidth',2) ;

subplot(2,1,2)
%image(A2)
%axis image off ;

A2gray = single(rgb2gray(A2)) ;
[f2,d2] = vl_sift(A2gray) ;
perm = randperm(size(f2,2)) ;
sel = perm(1:150) ;
%h1 = vl_plotframe(f2(:,sel)) ;
%h2 = vl_plotframe(f2(:,sel)) ;
set(h1,'color','k','linewidth',3) ;
set(h2,'color','y','linewidth',2) ;


[matches, scores] = vl_ubcmatch(d1, d2) ;
xa = f1(1,matches(1,:)) ;
xb = f2(1,matches(2,:)) ;
ya = f1(2,matches(1,:)) ;
yb = f2(2,matches(2,:)) ;

ind1 = ((abs(xa-xb)< 0.3*size(A1,2))&(abs(ya-yb)< 0.3*size(A1,1)));
ind1 = (ind1 & (yb < ya + 30) & (yb > ya - 0.25*size(A1,1)));
ind1 = (ind1 & (ya > 0.25*size(A1,1)));
ind1 = (ind1 & (ya < 0.9*size(A1,1)));
ind1 = (ind1 & (xa > (1/12)*size(A1,2)));
ind1 = (ind1 & (xa < (9/12)*size(A1,2)));
matches = matches(:, ind1);
matches = matches(:, 1:3:end);
matches = matches(:, [1:3 7:end]);
matches = matches(:, [1:4 7:end]);

%figure(1) ; clf ;
%imagesc(cat(1, A1, A2)) ;
%axis image off ;
%vl_demo_print('sift_match_1', 1) ;


Empty = zeros(40, size(A1,2), size(A1,3))+255;
figure(1) ; clf ;
image(cat(1, A1, Empty, A2)) ;

xa = f1(1,matches(1,:)) ;
xb = f2(1,matches(2,:)) ;
ya = f1(2,matches(1,:)) ;
yb = f2(2,matches(2,:)) + size(A1,1) + 40;

hold on ;
h = line([xa ; xb], [ya ; yb]) ;
set(h,'linewidth', 1, 'color', 'y') ;

f1(3,:) = 35;
f2(3,:) = 35;
vl_plotframe(f1(:, matches(1,:))) ;
f2b = f2;
f2b(2,:)  = f2(2,:) + size(A1,1) + 40 ;
vl_plotframe(f2b(:,[70 matches(2,:) 86])) ;
axis image off ;
%saveas(gcf,'Ani_matchings','fig')
%vl_demo_print('sift_match_2', 1) ;

xa = f1(1,matches(1,:)) ;
xb = f2(1,[70 matches(2,:) 86]) ;
ya = f1(2,matches(1,:)) ;
yb = f2(2,[70 matches(2,:) 86]) ;

N = size(f1(:, matches(1,:)),2);

% We wish now to plot the patches 

I3 = 250 + zeros(35, 400 ,3);

i_left = 0;
for i=1:N
    i_left = i_left + 11;
    xx = round(xa(i));
    yy = round(ya(i));
    I3(:, i_left:(i_left+34),:) = A1((yy-17):(yy+17),(xx-17):(xx+17),:);
    i_left = i_left + 35 + 11;
end


k=22;
I4 = 250 + zeros(2*k+1, (2*k+1)*9 + 9*16 ,3);

perm = randperm(N+2);
i_left = 0;
for i=1:(N+2)
    i_left = i_left + 8;
    j = perm(i);
    xx = round(xb(j));
    yy = round(yb(j));
    I4(:, i_left:(i_left+2*k),:) = A2((yy-k):(yy+k),(xx-k):(xx+k),:);
    i_left = i_left + 2*k + 8;
end


I3 = imresize(I3, [450 5500]);
I4 = imresize(I4, [450 5500]);
Empty = I3*0 + 255;
I34 = cat(1, I3, Empty, Empty, I4) ;

sum(I34==0);
I34(isnan(I34))=255;

figure(2)
image(uint8(I34));
axis image off ;


hAxis(1) = subplot(2,1,1);
imagesc(uint8(I3));
axis image off ;

pos = get( hAxis(1), 'Position' );
pos(2) = 0.5;
set( hAxis(1), 'Position', pos ) ;

hAxis(2) = subplot(2,1,2);
imagesc(uint8(I4));
axis image off ;


saveas(gcf,'Ani_mpatches','fig');
saveas(gcf,'Ani_mpatches','png');
saveas(gcf,'Ani_mpatches','pdf');

